<?php
	/*
     LogzMon 1.4, Log Viewer and Monitor
     Copyright (C) 2007 methodica, Hans E. Herger

     This program is free software: you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation, version 3 of the License.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
     The author may UNDER NO CIRCUMSTANCES BE MADE LIABLE FOR ANY
     CONSEQUENCES OF USING THE PROGRAM. IF THIS WAIVER OF ALL LIABILITY
     CONTRADICTS THE LAW WHERE YOU INTEND TO USE THE PROGRAM ITS USE IS
     STRICTLY PROHIBITED.
     See the GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program.  If not, see <http://www.gnu.org/licenses/>.
	*/

	define("logviewer_name","LogzMon",true);
	define("author","methodica, Hans E. Herger", true);
	define("logviewer_version","1.4",true);
	$proto = (strtoupper($_SERVER["HTTPS"]) == 'ON') ? "https://" : "http://";
	$script_url = $proto . getenv("SERVER_NAME") . ":" . getenv("SERVER_PORT") . $_SERVER["PHP_SELF"];

	if(strtoupper(substr(PHP_OS,0,3)=='WIN')){
		$newLine="\r\n";
		$delim  = "\\";
		define("CRLF", "\r\n", true);
	}elseif(strtoupper(substr(PHP_OS,0,3)=='MAC')){
		$newLine="\r";
		$delim  = "/";
		define("CRLF", "\r", true);
	}else{
		$newLine="\n";
		$delim  = "/";
		define("CRLF", "\r\n", true);
	}

	global $script_url;
	global $delim;
	global $newline;

	$params = array(); global $params;
	$pars = explode('&',$_SERVER['QUERY_STRING']);
	foreach($pars as $x_q){
		$x_p = split("=", $x_q);
		$params[strtoupper($x_p[0])] = $x_p[1];
	}
	global $user;
	$user = (isset($params['USER'])) ? $params['USER'] : '';
	$init = ( (isset($params['MODE'])) && (strtoupper($params['MODE'])=='INIT') );		// set up frame page
	$updc = ( (isset($params['MODE'])) && (strtoupper($params['MODE'])=='UPDATECHECK') ); // set up frame page
	$indx = ( (isset($params['MODE'])) && (strtoupper($params['MODE'])=='INDEX') );		// collect file list
	$cont = ( (isset($params['MODE'])) && (strtoupper($params['MODE'])=='CONTENT') );  // display file or archive contents

	$init = $init || (!$updc & !$indx & !$cont);
	$file = (isset($params['FIL'])) ? $params['FIL'] : '';								// fil=... when mode=content
	$arch = (isset($params['ARC'])) ? $params['ARC'] : '';								// arc=... when mode=content
	$entr = (isset($params['ENT'])) ? $params['ENT'] : '';								// ent=... when mode=content and arc=...
	$slin = (isset($params['LIN'])) ? (integer)$params['LIN'] : 0;						// lin=... when mode=content
	$mlin = (isset($params['LIM'])) ? (integer)$params['LIM'] : 0;						// lim=... when mode=content
	if (strtoupper($mlin)=='ALL') { $mlin = -1; }
	elseif ((strlen($mlin)<1) || (strtoupper($mlin)=='STD')) { $mlin = 0; }
	else {$mlin = (integer)$mlin; }
	$auto = (isset($params['AUT'])) ? (strtoupper($params['AUT'])=='YES') : false;      // lin=... when mode=content

	global $nrmtxt;
	global $errtxt;
	global $logfiles;
	global $logdirs;
	global $filters;
	global $filerset;
	global $actions;
	global $archivedirs;
	$logfiles = array();
	$archivepath = array();
	$filters = array();
	$filterset = array();
	$actions = array();

	require_once("logviewer_config.inc.php");
	global $msg;

	$msg = array();
	if (!defined('language')) { define('language','en'); }
	require_once("logviewer_lang_" . language . ".php");

	define("err_str", "\$ERROR\$", true); define("err_end", "\$/ERROR\$", true);
	define("wrn_str", "\$WARNING\$", true); define("wrn_end", "\$/WARNING\$", true);
	define("sta_str", "\$STATUS\$", true); define("sta_end", "\$/STATUS\$", true);
	define("ind_str", "\$INDEX\$", true); define("ind_end", "\$/INDEX\$", true);
	define("con_str", "\$CONTENT\$", true); define("con_end", "\$/CONTENT\$", true);
	define("lin_str", "\$LINE\$", true); define("lin_end", "\$/LINE\$", true);

	define('regex','/([\d]{1,3}\.[\d]{1,3}\.[\d]{1,3}\.[\d]{1,3})( |\])/');
	define('repla','<a class="mx" {style} href="'.$msg[19].'" title=" '.$msg[15].' " target="_blank">$1</a>$2');
	define('regex1',' \&quot\;((http|https)://.*)\&quot\; i');
	define('repla1',' &quot;<a class="mx" {style} href="$1" title=" '.$msg[36].' " target="_blank">$1</a>&quot; ');
	define('regex2','^([\w-_\.]*)( - )');
	define('repla2','<a class="mx" {style} href="'.$msg[19].'" title=" '.$msg[37].' " target="_blank">$1</a>$2');

    $OUT = '';

	$flist = array();		// List of non-archived files
	$alist = array();		// List of files in archives

	// We do not want our output to be cached by browsers
	header("Expires: Mon, 01 Jan 1999 00:00:00 GMT"); // Date in the past
	header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); // Always modified
	header("Cache-Control: private, no-store, no-cache, must-revalidate"); // HTTP/1.1
	header("Cache-Control: post-check=0, pre-check=0", false);
	header("Pragma: no-cache"); // HTTP/1.0
	// Standard charset
    header("Content-type: text/html; charset=ISO-8859-1"); //
// --------------- METHODICA VARIANT ONLY: BEGIN --------------------
    if ($updc) {
        require_once 'HTML/Template/ITX.php';
		$tpl = new HTML_Template_ITX('./templates');
		$tpn = "lvcheck.htm.tpl";
		$tpl->loadTemplatefile($tpn, false, false);

		$tpl->setVariable('logviewer_name',logviewer_name);
		$tpl->setVariable('logviewer_version',logviewer_version);
		$tpl->setVariable('author',author);
		$tpl->setVariable('logviewer_url',$script_url);
		$tpl->setVariable('host_name',host_name);
		$tpl->setVariable('host_name_url',host_name_url);
		$tpl->setVariable('language',language);
		for ($i = 0; $i < count($msg); $i++) {
		    $vn = 'msg_'.$i;
		    $vv = $xf1 = preg_replace('/\$/', '\\\$', $msg[$i]);
		    $tpl->setVariable($vn,$vv);
		}
		$v1 = explode('.',logviewer_version);
			if (!isset($v1[0])) { $v1[0]=0; } else { $v1[0] = (integer)$v1[0]; }
			if (!isset($v1[1])) { $v1[1]=0; } else { $v1[1] = (integer)$v1[1]; }
			if (!isset($v1[2])) { $v1[2]=0; } else { $v1[2] = (integer)$v1[2]; }
		$v2 = explode('.',$params['VERSION']);
			if (!isset($v2[0])) { $v2[0]=0; } else { $v2[0] = (integer)$v2[0]; }
			if (!isset($v2[1])) { $v2[1]=0; } else { $v2[1] = (integer)$v2[1]; }
			if (!isset($v2[2])) { $v2[2]=0; } else { $v2[2] = (integer)$v2[2]; }
		$gt = ($v1[0]>$v2[0]) ? 1 : ( ($v1[0]<$v2[0]) ? -1 : 0 );
		if ($gt==0) { $gt = ($v1[1]>$v2[1]) ? 1 : ( ($v1[1]<$v2[1]) ? -1 : 0 ); }
		if ($gt==0) { $gt = ($v1[2]>$v2[2]) ? 1 : ( ($v1[2]<$v2[2]) ? -1 : 0 ); }
		$tpl->setVariable('current_version',preg_replace('/\$1/', $v1[0].'.'.$v1[1].'.'.$v1[2], $msg[20]));
		$tpl->setVariable('your_version',preg_replace('/\$1/', $v2[0].'.'.$v2[1].'.'.$v2[2], $msg[21]));
		if ($gt>0) {
			$tpl->setVariable('uptodate','<a href="http://tools.methodica.info/htm_'.language.'/logviewer/download/index.htm">'.$msg[22].'</a>.');
			$tpl->setVariable('doupdate','');
		} elseif ($gt==0) {
			$tpl->setVariable('uptodate',$msg[23]);
			$tpl->setVariable('doupdate','');
		} else {
			$tpl->setVariable('uptodate',$msg[24]);
			$tpl->setVariable('doupdate','');
		}
		$tpl->setCurrentBlock();
		$tpl->parseCurrentBlock();
		$tpl->show();
    	return;
    }
// --------------- METHODICA VARIANT ONLY: END ----------------------

    if ($init) {
    	// set up frame page according to template...
        require_once 'HTML/Template/ITX.php';
		$tpl = new HTML_Template_ITX('./templates');
		$tpn = "logviewer.htm.tpl";
		$tpl->loadTemplatefile($tpn, false, false);

		$tpl->setVariable('logviewer_name',logviewer_name);
		$tpl->setVariable('logviewer_version',logviewer_version);
		$tpl->setVariable('author',author);
		$tpl->setVariable('logviewer_url',$script_url);
		$tpl->setVariable('host_name',host_name);
		$tpl->setVariable('host_name_url',host_name_url);
		$tpl->setVariable('language',language);
		$tpl->setVariable('user',$user);
		$tpl->setVariable('refresh_interval_seconds',refresh_interval_seconds);
		$tpl->setVariable('refresh_test_milliseconds',refresh_test_milliseconds);
		$size = (isset($params['SIZE'])) ? strtolower($params['SIZE']) : ( empty($_COOKIE["size"]) ? '' : $_COOKIE["size"] );
		if ($mlin==0) { $mlin = ( empty($_COOKIE["mlin"]) ? 1000 : $_COOKIE["mlin"] ); }
		if ( (strlen($size)<1) && (defined('size')) ) { $size = strtolower(size); }
		if ( ($size=='standard') || ($size=='medium') ) { $size = ''; }
		setcookie("size", $size, time()+86400);
		setcookie("mlin", $mlin, time()+86400);
		$mlin = (integer)$mlin;

		if ( ($size=='small') || ($size=='large') ) { $siz = '_'.$size; } else { $siz = ''; }
		$tpl->setVariable('size', $siz);
		for ($i = 0; $i < count($msg); $i++) {
		    $vn = 'msg_'.$i;
		    $vv = $xf1 = preg_replace('/\$/', '\\\$', $msg[$i]);
		    $tpl->setVariable($vn,$vv);
		}
//		$lopt = '<option selected value="STD" title="'.$msg[27].'"'.(($mlin==-1)?' selected':'').'>&nbsp;&nbsp;&nbsp;STD</option>'."\n";
		$lopt = '<option value="250"'.(($mlin==250)?' selected':'').'>&nbsp;&nbsp;&nbsp;250</option>'."\n";
		$lopt .= '<option value="500"'.(($mlin==500)?' selected':'').'>&nbsp;&nbsp;&nbsp;500</option>'."\n";
		$lopt .= '<option value="1000"'.(($mlin==1000)?' selected':'').'>&nbsp;&nbsp;1000</option>'."\n";
		$lopt .= '<option value="2500"'.(($mlin==2500)?' selected':'').'>&nbsp;&nbsp;2500</option>'."\n";
		$lopt .= '<option value="5000"'.(($mlin==5000)?' selected':'').'>&nbsp;&nbsp;5000</option>'."\n";
		$lopt .= '<option value="7500"'.(($mlin==7500)?' selected':'').'>&nbsp;&nbsp;7500</option>'."\n";
		$lopt .= '<option value="10000"'.(($mlin==10000)?' selected':'').'>&nbsp;10000</option>'."\n";
		$lopt .= '<option value="25000"'.(($mlin==25000)?' selected':'').'>&nbsp;25000</option>'."\n";
		$lopt .= '<option value="50000"'.(($mlin==50000)?' selected':'').'>&nbsp;50000</option>'."\n";
		$lopt .= '<option value="75000"'.(($mlin==75000)?' selected':'').'>&nbsp;75000</option>'."\n";
		$lopt .= '<option value="ALL" title="'.$msg[28].'" '.(($mlin==0)?' selected':'').'>&nbsp;&nbsp;&nbsp;ALL</option>'."\n";
		$tpl->setVariable('loptions',$lopt);

		$tpl->setCurrentBlock();
		$tpl->parseCurrentBlock();
		$tpl->show();
    	return;
    }

	setcookie("mlin", $mlin, time()+86400);

	if ($indx) {
	    if (PHP_VERSION < '5') { require_once('scandir.inc.php'); }

		// display index (files and contents of archives)
		$cnt = 0;  global $cnt;
		$cnt1 = 0; global $cnt1;
		$cnta = 0; global $cnta;

		echo ind_str . "||";

		echo "<p style=\"padding:2px; text-align:center; margin-top:-4px; margin-bottom:2px; margin-left:-4px; margin-right:-4px; background-color:#B5E9FF; color:#000000; font-weight:bold;\">".$msg[7]."</p>||";
		foreach ($logdirs as $dir ) {
          $files = scandir( $dir[0] . $delim, 1 );
		  foreach ($files as $file_num => $file ) {
		  	doIndex($dir, $file, 1);
		  } // foreach ($files ...
		} // foreach ($logdirs

		foreach ($logfiles as $file ) {
			doIndex($file,'',3);
		} // foreach ($logfiles

		echo "<p style=\"padding:2px; text-align:center; margin-top:4px; margin-bottom:2px; margin-left:-4px; margin-right:-4px; background-color:#B5E9FF; color:#000000; font-weight:bold;\">".$msg[11]."</p>||";
		foreach ($archivedirs as $dir ) {
		  $archi = scandir( $dir[0] . $delim, 1 );
		  foreach ($archi as $file_num => $file ) {
		  	doIndex($dir, $file, 2);
		  } // foreach ($archi ...
		} // foreach ($archivedirs ...

		echo ind_end . "||";
		echo con_str . "||"; echo con_end . "||";
		$tx = $msg[8];
		$tx = preg_replace('/\$1/', $cnt, $tx);
		$tx = preg_replace('/\$2/', $cnt1, $tx);
		$tx = preg_replace('/\$3/', $cnta, $tx);
		echo sta_str . "||$tx||" . sta_end;
	} // if ($indx)

	if ($cont) {
		// display file contents (in directory, in archive)
		$cnt = 0;
		$cnta = 0;
		$flin = 0;
		$totl = 0;
		$filx = '';
		$arcx = '';
		$firstline=true;
		if (strlen($file)>0) {
			echo con_str;
	        $arcx = $msg[12];
			$file = rawurldecode($file);
			if (count($filterset)>0) {
				foreach($filterset as $fset) {
					if (eregi($fset[0], $file)) {
					    $filters = array();
						for ($i = 1; $i < count($fset); $i++) { $filters[] = $fset[$i]; }
						break;
					}
				}
			}
		    $filx = $file;
			$lines = file ($file);
			$totl = count($lines);
			$clim = 0;
			$sslin = $slin;
			if ( ($mlin>0) && ( ($slin<0) || ($slin>count($lines)) ) ) {
				$slin = count($lines) - $mlin;
				if ($slin<0) { $slin=0; }
				if ($auto) { $sslin = count($lines); }
			}
			if ($slin>=count($lines)) { $slin = 0; $sslin = 0; }
			if ($slin < 0) {                                  // to the end, no limit set
				$slin = 0; $auto = false;
			}
			if ($auto && ($mlin>0)) {                         // auto-refresh, limit set
				$slin = count($lines) - $mlin;
				if ($slin < 0) { $slin = 0; }
			}
			doCont($lines);
			if ($cnta<1) { echo ' '; }
			echo con_end . "||";
	    } elseif (strlen($arch)>0) {
			echo con_str;
	        $arcx = $msg[13];
			$arch = rawurldecode($arch);
			if (count($filterset)>0) {
				foreach($filterset as $fset) {
					if (eregi($fset[0], $arch)) {
					    $filters = array();
						for ($i = 1; $i < count($fset); $i++) { $filters[] = $fset[$i]; }
						break;
					}
				}
			}
		    $filx = $arch;
			$pi = pathinfo($arch);
	        if ( (isset($pi["extension"])) && (strtolower($pi["extension"])=='zip')) {
				require_once('zip.lib.php');
				$zip = zip_open($arch);
				if ($zip) {
					while ($zip_entry = zip_read($zip)) {
						if (zip_entry_name($zip_entry) == $ent) {
							if (count($filterset)>0) {
								foreach($filterset as $fset) {
									if (eregi($fset[0], zip_entry_name($zip_entry))) {
						    			$filters = array();
										for ($i = 1; $i < count($fset); $i++) { $filters[] = $fset[$i]; }
										break;
									}
								}
							}
							$filx .= ' -&gt; ' . zip_entry_name($zip_entry);
							if (zip_entry_open($zip, $zip_entry, "r")) {
								$buf = zip_entry_read($zip_entry, zip_entry_filesize($zip_entry));
								$lines = explode(CRLF,$buf);
								$totl = count($lines);
								$clim = 0;
								if ($slin>=count($lines)) { $slin = 0; } //
								$sslin = $slin;
								if ( ($mlin>0) && ( ($slin<0) || ($slin>count($lines)) ) ) { $slin = count($lines) - $mlin; }
								if ($slin>count($lines)) { $slin = 0; $sslin = 0; }
								if ($slin < 0) { $slin = 0; }
								doCont($lines);
								zip_entry_close($zip_entry);
							} else {
								echo err_str .'Cannot open ZIP entry '.zip_entry_name($zip_entry).err_end;
							}
							break;
						} // if (zip_entry_name
					} // while ($zip_entry
					zip_close($zip);
				} else {
					echo err_str .'Cannot open ZIP archive '.$arch.err_end;
				} // if ($zip) ...
			} elseif ( (isset($pi["extension"])) && (strtolower($pi["extension"])=='gz')) {
				$lines = gzfile($arch);
				$totl = count($lines);
				$clim = 0;
				if ($slin>=count($lines)) { $slin = 0; } //
				$sslin = $slin;
				if ( ($mlin>0) && ( ($slin<0) || ($slin>count($lines)) ) ) {
					$slin = count($lines) - $mlin;
					if ($auto) { $sslin = count($lines); }
				}
				if ( ($mlin>0) && ( ($slin<0) || ($slin>count($lines)) ) ) { $slin = count($lines) - $mlin; }
				if ($slin>count($lines)) { $slin = 0; $sslin = 0; }
				if ($slin < 0) { $slin = 0; }
				doCont($lines);
			} // if (strtolower($pi["extension"])
			if ($cnta<1) { echo ' '; }
			echo con_end . "||";
	    }
		echo lin_str . $cnt . lin_end;
		$slin++;
		$tx = preg_replace('/\$1/', $arcx, $msg[9]);
		$tx = preg_replace('/\$2/', $filx, $tx);
		$tx = preg_replace('/\$3/', $cnta.' / '.$slin.'-'.$cnt.' ('.$totl.')', $tx);
		echo sta_str . "||$tx||" . sta_end;
	} // if ($cont)
return;

function doIndex($dir, $file, $mode) {
	global $cnt;
	global $cnt1;
	global $cnta;
	global $delim;
	global $newline;
	global $params;
	global $script_url;

	if ( ($file=='.') || ($file=='..') ) { return; }

	if (strlen($file)>0) {
		$xf = $dir[0] . $delim . $file;
		$pi = pathinfo($xf);
	} else {
		$xf = $dir[0];
		$pi = pathinfo($xf);
		$file = $pi["basename"];
	}
	$xf1 = preg_replace('/\\\\/', '\\\\\\\\', $xf);
	$ext = (isset($pi["extension"])) ? strtolower($pi["extension"]) : "";
	if ( ($mode==2) && eregi ( '_'.$ext.'_', arcext ) ) {
		$cnt1++;
		if ($ext=='zip') {
			require_once('zip.lib.php');
			$zip = zip_open($xf);
			if ($zip) {
				$cmt = (isset($dir[1]) ? ' '.$dir[1] : '');
				$tx = $file.$cmt;
				$tx = preg_replace('/ /', '&nbsp;', $tx);
				echo '<p><a class="llnk1" title=" ' . $xf . ' " onmouseover="mover(this);" onmouseout="mout(this);" onclick="stopAuto(true); auto_allowed=false; togglepnl(\'auto$' . $cnt1 . '\'); return true;">' . $tx . '</a></p>';
				echo '<div id="auto$' . $cnt1 . '" class="autopnl" style="display: none;">';
				$zz = array();
				while ($zip_entry = zip_read($zip)) {
					$zz[] = zip_entry_name($zip_entry);
				} // while ($zip_entry...
				$zz = array_reverse($zz);
					foreach ($zz as $zip_item) {
						$cnt++; $cnta++;
						$tx = preg_replace('/ /', '&nbsp;', $zip_item);
						echo '<p>&nbsp;&nbsp;&nbsp;<a href="javascript:stopAuto(true); auto_allowed=false; lookupData(\''.$script_url.'\',\'content\',\'user='.$params['USER'].'&mode=CONTENT&arc=' . $xf1 . '&ent=' . $zip_item . '\',\'GET\');" title=" '.$zip_item.$cmt.' ">' . $tx . '</a></p>' . "||";
					} // foreach ($zz...
					echo '</div>';
					zip_close($zip);
			} // if ($zip)
		} elseif ($ext=='gz') {
    		$cmt = (isset($dir[1]) ? ' '.$dir[1] : '');
    		$cnta++;
    		$tx = $file.$cmt;
    		$tx = preg_replace('/ /', '&nbsp;', $tx);
    		echo '<p><a href="javascript:stopAuto(true); auto_allowed=false; lookupData(\''.$script_url.'\',\'content\',\'user='.$params['USER'].'&mode=CONTENT&arc=' . $xf1 . '&ent=' . $zip_item . '\',\'GET\');" title=" '.$xf.' ">' . $tx . '</a></p>' . "||";
		} // if (strtolower($pi[ ...
	} // if ( (($mode==2) ...
	if ( ( ($mode==1) && eregi ( '_'.$ext.'_', logext ) ) || ($mode==3) ) {
   		$cnt++;
   		$cmt = (isset($dir[1]) ? ' '.$dir[1] : '');
   		$tx = $file.$cmt;
   		$tx = preg_replace('/ /', '&nbsp;', $tx);
   		echo '<p><a href="javascript:stopAuto(true); auto_allowed=true; ExpandCollapseAll(false); lookupData(\''.$script_url.'\',\'content\',\'user='.$params['USER'].'&mode=CONTENT&fil=' . $xf1 . '\',\'GET\');" title=" ' . $xf . '  ">' . $tx . '</a></p>' . "||";
	} // if ( (($mode&1)==1)  ...
	return;
}

function doCont($lines) {
	global $cnt;
	global $cnta;
	global $slin;
	global $flin;
	global $sslin;
	global $mlin;
	global $clim;
	global $firstline;
	global $msg;
	global $filters;
	global $actions;
	global $filx;
	global $auto;

	foreach ($lines as $line_num => $line) {
		$cnt++;
		if ($cnt>$slin) {
		    if ( ($mlin>0) && $firstline && ($cnt>1) ) {
		    	echo '<p><a style="color:#ffffff; background-color:#333333;" href="javascript:stopAuto(false); goRelative(-2);" title="'.$msg[30].'">&nbsp;&laquo;&nbsp;<b>'.$msg[30].'</b>&nbsp;</a></p>';
		    }
	    	$firstline = false;
			$clim++;
			if ( ($mlin>0) && ($clim > $mlin) ) {
				$cnt--;
			    if ($cnt<count($lines)) {
			    	echo '<p><a style="color:#ffffff; background-color:#333333;" href="javascript:stopAuto(false); goRelative(+0);" style="text-decoration:none; color:#ffffff;" title="'.$msg[31].'">&nbsp;<b>'.$msg[31].'</b>&nbsp;&raquo;&nbsp;</a></p>';
			    }
				break;
			}
			$line = preg_replace('/[\r\n]/', '', $line);
			if (strlen($line)<1) {
				echo '<p><span style="color:#ffffff; background-color:#333333;">&nbsp;</span>';
				$cnta++;
				continue;
			} else {
				$st = ' style="color:#000000;"';
			}
			foreach ($filters as $filter) {
			  if (eregi($filter[0], $line)) {
	    		if ($auto && ($cnt>$sslin) && (isset($filter[3])) ) {
		    		// For currrent files only: send message ?
		    		$addon = '';
		    		foreach($actions as $action) {
		    		  $actn = strtolower($action[0]);
		    		  $flt = explode('|',strtolower($filter[3]));
		    		  foreach ($flt as $xf) {
			    		if ($actn == $xf) {
			    			$msgt = strtolower($action[1]);
			    			$addon = 'addon_'.$msgt.'.php';
			    			require_once($addon);
			    			if       ($msgt == 'smtpmail') {
								$rs = send_smtpmail($action[2],$action[3],$action[4],ereg_replace(CRLF,'',$line),$filx);
//							} elseif ($msgt == 'sendmail') {
//								$rs = send_sendmail($action[2],$action[3],$action[4],ereg_replace(CRLF,'',$line),$filx);
							} elseif ($msgt == 'smsclick') {
								$rs = send_smsclick($action[2],$action[3],$action[4],ereg_replace(CRLF,'',$line),$filx);
							} elseif ($msgt == 'syslog') {
								$rs = send_syslog($action[2],$action[3],$action[4],ereg_replace(CRLF,'',$line),$filx);
							}
			    		}
		    		  }
		    		}
		    	}
			    if (strtoupper($filter[1])=='HIDE') { continue 2; }
			    $st = ' style="color:'.$filter[1].'; background-color:'.$filter[2].';"';
			    break;
			  }
			}
		    $cnta++;
		    $line = htmlspecialchars(ereg_replace(CRLF,'',$line));
			if (!SuppressHttpLookups) {
				$line = preg_replace( regex1, preg_replace('{style} ',$st,repla1), $line );
			}
			if (!SuppressIpLookups) {
				$lg = strlen($line);
				$line = preg_replace( regex, preg_replace('{style} ',$st,repla), $line );
				if (strlen($line) == $lg) {
					$line = preg_replace( regex2, preg_replace('{style} ',$st,repla2), $line );
				}
			}
	    	if (strlen($line)>0) { echo '<p'.$st.'>' . $line . '</p>'; }
	    }
	}
}

?>

